/**
 * DevExtreme (renovation/ui/scheduler/workspaces/base/header_panel/date_header/layout.js)
 * Version: 21.1.0 (build 21032-0316)
 * Build date: Mon Feb 01 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.DateHeaderLayout = DateHeaderLayout;
exports.DateHeaderLayoutProps = exports.viewFunction = void 0;
var _row = require("../../row");
var _utils = require("../../../utils");
var _cell = require("./cell");
var _consts = require("../../../../consts");
var Preact = _interopRequireWildcard(require("preact"));
var _hooks = require("preact/hooks");

function _getRequireWildcardCache() {
    if ("function" !== typeof WeakMap) {
        return null
    }
    var cache = new WeakMap;
    _getRequireWildcardCache = function() {
        return cache
    };
    return cache
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    }
    if (null === obj || "object" !== _typeof(obj) && "function" !== typeof obj) {
        return {
            default: obj
        }
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj)
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc)
            } else {
                newObj[key] = obj[key]
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj)
    }
    return newObj
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter((function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            }))
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach((function(key) {
                _defineProperty(target, key, source[key])
            }))
        } else if (Object.getOwnPropertyDescriptors) {
            Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
        } else {
            ownKeys(Object(source)).forEach((function(key) {
                Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
            }))
        }
    }
    return target
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}
var viewFunction = function(_ref) {
    var isHorizontalGrouping = _ref.isHorizontalGrouping,
        _ref$props = _ref.props,
        dateCellTemplate = _ref$props.dateCellTemplate,
        dateHeaderMap = _ref$props.dateHeaderMap;
    return Preact.h(Preact.Fragment, null, dateHeaderMap.map((function(dateHeaderRow, rowIndex) {
        return Preact.h(_row.Row, {
            className: "dx-scheduler-header-row",
            key: rowIndex.toString()
        }, dateHeaderRow.map((function(_ref2) {
            var colSpan = _ref2.colSpan,
                endDate = _ref2.endDate,
                groupIndex = _ref2.groupIndex,
                cellGroups = _ref2.groups,
                index = _ref2.index,
                isFirstGroupCell = _ref2.isFirstGroupCell,
                isLastGroupCell = _ref2.isLastGroupCell,
                key = _ref2.key,
                startDate = _ref2.startDate,
                text = _ref2.text,
                today = _ref2.today;
            return Preact.h(_cell.DateHeaderCell, {
                startDate: startDate,
                endDate: endDate,
                groups: isHorizontalGrouping ? cellGroups : void 0,
                groupIndex: isHorizontalGrouping ? groupIndex : void 0,
                today: today,
                index: index,
                text: text,
                isFirstGroupCell: isFirstGroupCell,
                isLastGroupCell: isLastGroupCell,
                dateCellTemplate: dateCellTemplate,
                key: key,
                colSpan: colSpan
            })
        })))
    })))
};
exports.viewFunction = viewFunction;
var DateHeaderLayoutProps = {
    groupOrientation: _consts.HORIZONTAL_GROUP_ORIENTATION,
    dateHeaderMap: [],
    groups: []
};
exports.DateHeaderLayoutProps = DateHeaderLayoutProps;
var getTemplate = function(TemplateProp) {
    return TemplateProp && (TemplateProp.defaultProps ? function(props) {
        return Preact.h(TemplateProp, _extends({}, props))
    } : TemplateProp)
};

function DateHeaderLayout(props) {
    var __isHorizontalGrouping = (0, _hooks.useCallback)((function() {
        var groupOrientation = props.groupOrientation,
            groups = props.groups;
        return (0, _utils.isHorizontalGroupOrientation)(groups, groupOrientation)
    }), [props.groupOrientation, props.groups]);
    var __restAttributes = (0, _hooks.useCallback)((function() {
        props.dateCellTemplate, props.dateHeaderMap, props.groupOrientation, props.groups;
        var restProps = _objectWithoutProperties(props, ["dateCellTemplate", "dateHeaderMap", "groupOrientation", "groups"]);
        return restProps
    }), [props]);
    return viewFunction({
        props: _objectSpread(_objectSpread({}, props), {}, {
            dateCellTemplate: getTemplate(props.dateCellTemplate)
        }),
        isHorizontalGrouping: __isHorizontalGrouping(),
        restAttributes: __restAttributes()
    })
}
DateHeaderLayout.defaultProps = _objectSpread({}, DateHeaderLayoutProps);
