/**
 * DevExtreme (renovation/ui/scroll_view/scrollable_simulated.js)
 * Version: 21.1.0 (build 21032-0316)
 * Build date: Mon Feb 01 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.ScrollableSimulated = exports.viewFunction = void 0;
var _subscribe_to_event = require("../../utils/subscribe_to_event");
var _scrollbar = require("./scrollbar");
var _widget = require("../common/widget");
var _combine_classes = require("../../utils/combine_classes");
var _index = require("../../../events/utils/index");
var _window = require("../../../core/utils/window");
var _position = require("../../../core/utils/position");
var _inflector = require("../../../core/utils/inflector");
var _type = require("../../../core/utils/type");
var _deferred = require("../../../core/utils/deferred");
var _scrollable_simulated_props = require("./scrollable_simulated_props");
var _renderer = _interopRequireDefault(require("../../../core/renderer"));
var _scrollable_utils = require("./scrollable_utils");
var _top_pocket = require("./top_pocket");
var _bottom_pocket = require("./bottom_pocket");
var _short = require("../../../events/short");
var Preact = _interopRequireWildcard(require("preact"));
var _hooks = require("preact/hooks");
var _compat = require("preact/compat");

function _getRequireWildcardCache() {
    if ("function" !== typeof WeakMap) {
        return null
    }
    var cache = new WeakMap;
    _getRequireWildcardCache = function() {
        return cache
    };
    return cache
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    }
    if (null === obj || "object" !== _typeof(obj) && "function" !== typeof obj) {
        return {
            default: obj
        }
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj)
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc)
            } else {
                newObj[key] = obj[key]
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj)
    }
    return newObj
}

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter((function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            }))
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach((function(key) {
                _defineProperty(target, key, source[key])
            }))
        } else if (Object.getOwnPropertyDescriptors) {
            Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
        } else {
            ownKeys(Object(source)).forEach((function(key) {
                Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
            }))
        }
    }
    return target
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}

function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest()
}

function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")
}

function _unsupportedIterableToArray(o, minLen) {
    if (!o) {
        return
    }
    if ("string" === typeof o) {
        return _arrayLikeToArray(o, minLen)
    }
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if ("Object" === n && o.constructor) {
        n = o.constructor.name
    }
    if ("Map" === n || "Set" === n) {
        return Array.from(o)
    }
    if ("Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) {
        return _arrayLikeToArray(o, minLen)
    }
}

function _arrayLikeToArray(arr, len) {
    if (null == len || len > arr.length) {
        len = arr.length
    }
    for (var i = 0, arr2 = new Array(len); i < len; i++) {
        arr2[i] = arr[i]
    }
    return arr2
}

function _iterableToArrayLimit(arr, i) {
    if ("undefined" === typeof Symbol || !(Symbol.iterator in Object(arr))) {
        return
    }
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = void 0;
    try {
        for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done); _n = true) {
            _arr.push(_s.value);
            if (i && _arr.length === i) {
                break
            }
        }
    } catch (err) {
        _d = true;
        _e = err
    } finally {
        try {
            if (!_n && null != _i.return) {
                _i.return()
            }
        } finally {
            if (_d) {
                throw _e
            }
        }
    }
    return _arr
}

function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) {
        return arr
    }
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}
var KEY_CODES = {
    PAGE_UP: "pageUp",
    PAGE_DOWN: "pageDown",
    END: "end",
    HOME: "home",
    LEFT: "leftArrow",
    UP: "upArrow",
    RIGHT: "rightArrow",
    DOWN: "downArrow",
    TAB: "tab"
};
var VALIDATE_WHEEL_TIMEOUT = 500;
var viewFunction = function(viewModel) {
    var baseContainerHeight = viewModel.baseContainerHeight,
        baseContainerWidth = viewModel.baseContainerWidth,
        baseContentHeight = viewModel.baseContentHeight,
        baseContentWidth = viewModel.baseContentWidth,
        containerHeight = viewModel.containerHeight,
        containerRef = viewModel.containerRef,
        containerWidth = viewModel.containerWidth,
        contentHeight = viewModel.contentHeight,
        contentRef = viewModel.contentRef,
        contentWidth = viewModel.contentWidth,
        cssClasses = viewModel.cssClasses,
        cursorEnterHandler = viewModel.cursorEnterHandler,
        cursorLeaveHandler = viewModel.cursorLeaveHandler,
        horizontalScrollbarRef = viewModel.horizontalScrollbarRef,
        isScrollbarVisible = viewModel.isScrollbarVisible,
        onWidgetKeyDown = viewModel.onWidgetKeyDown,
        _viewModel$props = viewModel.props,
        bounceEnabled = _viewModel$props.bounceEnabled,
        children = _viewModel$props.children,
        direction = _viewModel$props.direction,
        disabled = _viewModel$props.disabled,
        forceGeneratePockets = _viewModel$props.forceGeneratePockets,
        height = _viewModel$props.height,
        inertiaEnabled = _viewModel$props.inertiaEnabled,
        needScrollViewContentWrapper = _viewModel$props.needScrollViewContentWrapper,
        pulledDownText = _viewModel$props.pulledDownText,
        pullingDownText = _viewModel$props.pullingDownText,
        reachBottomText = _viewModel$props.reachBottomText,
        refreshingText = _viewModel$props.refreshingText,
        rtlEnabled = _viewModel$props.rtlEnabled,
        scrollByThumb = _viewModel$props.scrollByThumb,
        showScrollbar = _viewModel$props.showScrollbar,
        useKeyboard = _viewModel$props.useKeyboard,
        width = _viewModel$props.width,
        restAttributes = viewModel.restAttributes,
        scaleRatioHeight = viewModel.scaleRatioHeight,
        scaleRatioWidth = viewModel.scaleRatioWidth,
        scrollableOffsetLeft = viewModel.scrollableOffsetLeft,
        scrollableOffsetTop = viewModel.scrollableOffsetTop,
        scrollableRef = viewModel.scrollableRef,
        verticalScrollbarRef = viewModel.verticalScrollbarRef,
        wrapperRef = viewModel.wrapperRef;
    var targetDirection = null !== direction && void 0 !== direction ? direction : "vertical";
    var isVertical = "horizontal" !== targetDirection;
    var isHorizontal = "vertical" !== targetDirection;
    return Preact.h(_widget.Widget, _extends({
        rootElementRef: scrollableRef,
        focusStateEnabled: useKeyboard,
        hoverStateEnabled: true,
        classes: cssClasses,
        disabled: disabled,
        rtlEnabled: rtlEnabled,
        height: height,
        width: width,
        onKeyDown: onWidgetKeyDown,
        onHoverStart: cursorEnterHandler,
        onHoverEnd: cursorLeaveHandler
    }, restAttributes), Preact.h("div", {
        className: _scrollable_utils.SCROLLABLE_WRAPPER_CLASS,
        ref: wrapperRef
    }, Preact.h("div", {
        className: _scrollable_utils.SCROLLABLE_CONTAINER_CLASS,
        ref: containerRef
    }, Preact.h("div", {
        className: _scrollable_utils.SCROLLABLE_CONTENT_CLASS,
        ref: contentRef
    }, forceGeneratePockets && Preact.h(_top_pocket.TopPocket, {
        pullingDownText: pullingDownText,
        pulledDownText: pulledDownText,
        refreshingText: refreshingText,
        refreshStrategy: "simulated"
    }), needScrollViewContentWrapper && Preact.h("div", {
        className: _scrollable_utils.SCROLLVIEW_CONTENT_CLASS
    }, children), !needScrollViewContentWrapper && children, forceGeneratePockets && Preact.h(_bottom_pocket.BottomPocket, {
        reachBottomText: reachBottomText
    })), isHorizontal && Preact.h(_scrollbar.Scrollbar, {
        direction: "horizontal",
        ref: horizontalScrollbarRef,
        containerRef: containerRef,
        contentRef: contentRef,
        scaleRatio: scaleRatioWidth,
        scrollableOffset: scrollableOffsetLeft,
        contentSize: contentWidth,
        containerSize: containerWidth,
        baseContentSize: baseContentWidth,
        baseContainerSize: baseContainerWidth,
        visible: isScrollbarVisible,
        scrollByThumb: scrollByThumb,
        bounceEnabled: bounceEnabled,
        showScrollbar: showScrollbar,
        inertiaEnabled: inertiaEnabled
    }), isVertical && Preact.h(_scrollbar.Scrollbar, {
        direction: "vertical",
        ref: verticalScrollbarRef,
        containerRef: containerRef,
        contentRef: contentRef,
        scaleRatio: scaleRatioHeight,
        scrollableOffset: scrollableOffsetTop,
        contentSize: contentHeight,
        containerSize: containerHeight,
        baseContentSize: baseContentHeight,
        baseContainerSize: baseContainerHeight,
        visible: isScrollbarVisible,
        scrollByThumb: scrollByThumb,
        bounceEnabled: bounceEnabled,
        showScrollbar: showScrollbar,
        inertiaEnabled: inertiaEnabled
    }))))
};
exports.viewFunction = viewFunction;
var ScrollableSimulated = (0, _compat.forwardRef)((function(props, ref) {
    var __scrollableRef = (0, _hooks.useRef)();
    var __wrapperRef = (0, _hooks.useRef)();
    var __contentRef = (0, _hooks.useRef)();
    var __containerRef = (0, _hooks.useRef)();
    var __verticalScrollbarRef = (0, _hooks.useRef)();
    var __horizontalScrollbarRef = (0, _hooks.useRef)();
    var _useState = (0, _hooks.useState)(false),
        _useState2 = _slicedToArray(_useState, 2),
        __state_isHovered = _useState2[0],
        __state_setIsHovered = _useState2[1];
    var _useState3 = (0, _hooks.useState)(void 0),
        _useState4 = _slicedToArray(_useState3, 2),
        __state_scaleRatioWidth = _useState4[0],
        __state_setScaleRatioWidth = _useState4[1];
    var _useState5 = (0, _hooks.useState)(void 0),
        _useState6 = _slicedToArray(_useState5, 2),
        __state_scaleRatioHeight = _useState6[0],
        __state_setScaleRatioHeight = _useState6[1];
    var _useState7 = (0, _hooks.useState)(0),
        _useState8 = _slicedToArray(_useState7, 2),
        __state_scrollableOffsetLeft = _useState8[0],
        __state_setScrollableOffsetLeft = _useState8[1];
    var _useState9 = (0, _hooks.useState)(0),
        _useState10 = _slicedToArray(_useState9, 2),
        __state_scrollableOffsetTop = _useState10[0],
        __state_setScrollableOffsetTop = _useState10[1];
    var _useState11 = (0, _hooks.useState)(0),
        _useState12 = _slicedToArray(_useState11, 2),
        __state_contentWidth = _useState12[0],
        __state_setContentWidth = _useState12[1];
    var _useState13 = (0, _hooks.useState)(0),
        _useState14 = _slicedToArray(_useState13, 2),
        __state_contentHeight = _useState14[0],
        __state_setContentHeight = _useState14[1];
    var _useState15 = (0, _hooks.useState)(0),
        _useState16 = _slicedToArray(_useState15, 2),
        __state_containerWidth = _useState16[0],
        __state_setContainerWidth = _useState16[1];
    var _useState17 = (0, _hooks.useState)(0),
        _useState18 = _slicedToArray(_useState17, 2),
        __state_containerHeight = _useState18[0],
        __state_setContainerHeight = _useState18[1];
    var _useState19 = (0, _hooks.useState)(0),
        _useState20 = _slicedToArray(_useState19, 2),
        __state_baseContentWidth = _useState20[0],
        __state_setBaseContentWidth = _useState20[1];
    var _useState21 = (0, _hooks.useState)(0),
        _useState22 = _slicedToArray(_useState21, 2),
        __state_baseContentHeight = _useState22[0],
        __state_setBaseContentHeight = _useState22[1];
    var _useState23 = (0, _hooks.useState)(0),
        _useState24 = _slicedToArray(_useState23, 2),
        __state_baseContainerWidth = _useState24[0],
        __state_setBaseContainerWidth = _useState24[1];
    var _useState25 = (0, _hooks.useState)(0),
        _useState26 = _slicedToArray(_useState25, 2),
        __state_baseContainerHeight = _useState26[0],
        __state_setBaseContainerHeight = _useState26[1];
    var _useState27 = (0, _hooks.useState)({}),
        _useState28 = _slicedToArray(_useState27, 2),
        __state_validDirections = _useState28[0];
    _useState28[1];
    var _useState29 = (0, _hooks.useState)({
            validateWheelTimer: void 0,
            locked: false,
            eventForUserAction: null
        }),
        _useState30 = _slicedToArray(_useState29, 2),
        __state_cachedVariables = _useState30[0];
    _useState30[1];
    var __getEventArgs = (0, _hooks.useCallback)((function() {
        return _objectSpread({
            event: __state_cachedVariables.eventForUserAction,
            scrollOffset: __scrollOffset()
        }, (0, _scrollable_utils.getBoundaryProps)(props.direction, __scrollOffset(), __containerRef.current))
    }), [__state_cachedVariables, props.rtlEnabled, props.direction]);
    var __cursorEnterHandler = (0, _hooks.useCallback)((function() {
        if (__isHoverMode()) {
            __state_setIsHovered((function(__state_isHovered) {
                return true
            }))
        }
    }), [props.showScrollbar]);
    var __cursorLeaveHandler = (0, _hooks.useCallback)((function() {
        if (__isHoverMode()) {
            __state_setIsHovered((function(__state_isHovered) {
                return false
            }))
        }
    }), [props.showScrollbar]);
    var __handleInit = (0, _hooks.useCallback)((function(e) {
        __suppressDirections(e);
        __state_cachedVariables.eventForUserAction = e;
        var crossThumbScrolling = __isThumbScrolling(e);
        __eventHandler((function(scrollbar) {
            return scrollbar.initHandler(e, props.onStop, crossThumbScrolling)
        }))
    }), [props.direction, props.scrollByContent, props.scrollByThumb, props.onStop]);
    var __handleStart = (0, _hooks.useCallback)((function(e) {
        __state_cachedVariables.eventForUserAction = e
    }), []);
    var __handleMove = (0, _hooks.useCallback)((function(e) {
        e.preventDefault && e.preventDefault();
        __adjustDistance(e, "delta");
        __state_cachedVariables.eventForUserAction = e;
        __eventHandler((function(scrollbar) {
            return scrollbar.moveHandler(e.delta)
        }))
    }), [__state_validDirections, props.direction]);
    var __handleEnd = (0, _hooks.useCallback)((function(e) {
        __adjustDistance(e, "velocity");
        __state_cachedVariables.eventForUserAction = e;
        __eventHandler((function(scrollbar) {
            return scrollbar.endHandler(e, props.onEnd)
        }))
    }), [__state_validDirections, props.direction, props.onEnd]);
    var __handleStop = (0, _hooks.useCallback)((function() {
        __eventHandler((function(scrollbar) {
            return scrollbar.stopHandler()
        }))
    }), [props.direction]);
    var __handleCancel = (0, _hooks.useCallback)((function(e) {
        __state_cachedVariables.eventForUserAction = e
    }), []);
    var __isThumbScrolling = (0, _hooks.useCallback)((function(e) {
        var scrollByThumb = props.scrollByThumb;
        var _ScrollDirection = new _scrollable_utils.ScrollDirection(props.direction),
            isHorizontal = _ScrollDirection.isHorizontal,
            isVertical = _ScrollDirection.isVertical;
        var target = e.originalEvent.target;
        var verticalScrolling;
        var horizontalScrolling;
        if (isVertical) {
            verticalScrolling = scrollByThumb && __verticalScrollbarRef.current.isThumb(target)
        }
        if (isHorizontal) {
            horizontalScrolling = scrollByThumb && __horizontalScrollbarRef.current.isThumb(target)
        }
        return verticalScrolling || horizontalScrolling
    }), [props.scrollByThumb, props.direction]);
    var __adjustDistance = (0, _hooks.useCallback)((function(e, property) {
        var distance = e[property];
        distance.x *= __state_validDirections[_scrollable_utils.DIRECTION_HORIZONTAL];
        distance.y *= __state_validDirections[_scrollable_utils.DIRECTION_VERTICAL];
        var devicePixelRatio = __tryGetDevicePixelRatio();
        if (devicePixelRatio && (0, _index.isDxMouseWheelEvent)(e.originalEvent)) {
            distance.x = Math.round(distance.x / devicePixelRatio * 100) / 100;
            distance.y = Math.round(distance.y / devicePixelRatio * 100) / 100
        }
    }), [__state_validDirections]);
    var __suppressDirections = (0, _hooks.useCallback)((function(e) {
        if ((0, _index.isDxMouseWheelEvent)(e.originalEvent)) {
            __prepareDirections(true);
            return
        }
        __prepareDirections(false);
        var _ScrollDirection2 = new _scrollable_utils.ScrollDirection(props.direction),
            isHorizontal = _ScrollDirection2.isHorizontal,
            isVertical = _ScrollDirection2.isVertical;
        if (isVertical) {
            var isValid = __validateEvent(e, __verticalScrollbarRef.current);
            __state_validDirections[_scrollable_utils.DIRECTION_VERTICAL] = isValid
        }
        if (isHorizontal) {
            var _isValid = __validateEvent(e, __horizontalScrollbarRef.current);
            __state_validDirections[_scrollable_utils.DIRECTION_HORIZONTAL] = _isValid
        }
    }), [props.direction, props.scrollByContent, props.scrollByThumb]);
    var __validateEvent = (0, _hooks.useCallback)((function(e, scrollbarRef) {
        var scrollByContent = props.scrollByContent,
            scrollByThumb = props.scrollByThumb;
        return scrollByThumb && scrollbarRef.validateEvent(e) || scrollByContent && __isContent(e.originalEvent.target)
    }), [props.scrollByContent, props.scrollByThumb]);
    var __prepareDirections = (0, _hooks.useCallback)((function(value) {
        __state_validDirections[_scrollable_utils.DIRECTION_HORIZONTAL] = value;
        __state_validDirections[_scrollable_utils.DIRECTION_VERTICAL] = value
    }), []);
    var __isContent = (0, _hooks.useCallback)((function(element) {
        var closest = element.closest(".dx-scrollable-simulated");
        if ((0, _type.isDefined)(closest)) {
            return closest === __scrollableRef.current
        }
        return false
    }), []);
    var __eventHandler = (0, _hooks.useCallback)((function(handler) {
        var _ScrollDirection3 = new _scrollable_utils.ScrollDirection(props.direction),
            isHorizontal = _ScrollDirection3.isHorizontal,
            isVertical = _ScrollDirection3.isVertical;
        var deferreds = [];
        if (isVertical) {
            deferreds.push(handler(__verticalScrollbarRef.current))
        }
        if (isHorizontal) {
            deferreds.push(handler(__horizontalScrollbarRef.current))
        }
        return _deferred.when.apply(_renderer.default, deferreds).promise()
    }), [props.direction]);
    var __getDirection = (0, _hooks.useCallback)((function(e) {
        return (0, _index.isDxMouseWheelEvent)(e) ? __wheelDirection(e) : __allowedDirection()
    }), [props.direction, props.bounceEnabled]);
    var __allowedDirection = (0, _hooks.useCallback)((function() {
        return (0, _scrollable_utils.updateAllowedDirection)(__allowedDirections(), props.direction)
    }), [props.bounceEnabled, props.direction]);
    var __allowedDirections = (0, _hooks.useCallback)((function() {
        var bounceEnabled = props.bounceEnabled,
            direction = props.direction;
        var _ScrollDirection4 = new _scrollable_utils.ScrollDirection(direction),
            isHorizontal = _ScrollDirection4.isHorizontal,
            isVertical = _ScrollDirection4.isVertical;
        return {
            vertical: isVertical && (Math.round(__verticalScrollbarRef.current.getMinOffset()) < 0 || bounceEnabled),
            horizontal: isHorizontal && (Math.round(__horizontalScrollbarRef.current.getMinOffset()) < 0 || bounceEnabled)
        }
    }), [props.bounceEnabled, props.direction]);
    var __containerSize = (0, _hooks.useCallback)((function(dimension) {
        return __getRealDimension(__containerRef.current, dimension)
    }), []);
    var __getRealDimension = (0, _hooks.useCallback)((function(element, dimension) {
        return Math.round((0, _position.getBoundingRect)(element)[dimension])
    }), []);
    var __getBaseDimension = (0, _hooks.useCallback)((function(element, dimension) {
        return element["offset".concat((0, _inflector.titleize)(dimension))]
    }), []);
    var __contentSize = (0, _hooks.useCallback)((function(dimension) {
        var axis = "width" === dimension ? "x" : "y";
        var overflowStyleName = "overflow".concat(axis.toUpperCase());
        var isOverflowHidden = "hidden" === (0, _scrollable_utils.getElementStyle)(overflowStyleName, __contentRef.current);
        var contentSize = __getRealDimension(__contentRef.current, dimension);
        if (!isOverflowHidden) {
            var containerScrollSize = __contentRef.current["scroll".concat((0, _inflector.titleize)(dimension))] * __getScaleRatio(dimension);
            contentSize = Math.max(containerScrollSize, contentSize)
        }
        return contentSize
    }), []);
    var __getScaleRatio = (0, _hooks.useCallback)((function(dimension) {
        var scaleRatio = 1;
        if ((0, _window.hasWindow)()) {
            var realDimension = __getRealDimension(__scrollableRef.current, dimension);
            var baseDimension = __getBaseDimension(__scrollableRef.current, dimension);
            scaleRatio = Math.round(realDimension / baseDimension * 100) / 100
        }
        return scaleRatio
    }), []);
    var __validate = (0, _hooks.useCallback)((function(e) {
        if (__isLocked()) {
            return false
        }
        if (props.disabled) {
            return false
        }
        if (props.bounceEnabled) {
            return true
        }
        return (0, _index.isDxMouseWheelEvent)(e) ? __validateWheel(e) : __validateMove(e)
    }), [__state_cachedVariables, props.disabled, props.bounceEnabled, props.direction, props.scrollByContent]);
    var __isLocked = (0, _hooks.useCallback)((function() {
        return __state_cachedVariables.locked
    }), [__state_cachedVariables]);
    var __validateWheel = (0, _hooks.useCallback)((function(e) {
        var scrollbar = "horizontal" === __wheelDirection(e) ? __horizontalScrollbarRef.current : __verticalScrollbarRef.current;
        var reachedMin = scrollbar.reachedMin();
        var reachedMax = scrollbar.reachedMax();
        var contentGreaterThanContainer = !reachedMin || !reachedMax;
        var locatedNotAtBound = !reachedMin && !reachedMax;
        var delta = e.delta;
        var scrollFromMin = reachedMin && delta > 0;
        var scrollFromMax = reachedMax && delta < 0;
        var validated = contentGreaterThanContainer && (locatedNotAtBound || scrollFromMin || scrollFromMax);
        validated = validated || void 0 !== __state_cachedVariables.validateWheelTimer;
        if (validated) {
            __clearWheelValidationTimer();
            __state_cachedVariables.validateWheelTimer = setTimeout(__clearWheelValidationTimer, VALIDATE_WHEEL_TIMEOUT)
        }
        return validated
    }), [props.direction, __state_cachedVariables]);
    var __clearWheelValidationTimer = (0, _hooks.useCallback)((function() {
        clearTimeout(__state_cachedVariables.validateWheelTimer);
        __state_cachedVariables.validateWheelTimer = void 0
    }), [__state_cachedVariables]);
    var __validateMove = (0, _hooks.useCallback)((function(e) {
        if (!props.scrollByContent && !(0, _type.isDefined)(e.target.closest(".".concat(_scrollable_utils.SCROLLABLE_SCROLLBAR_CLASS)))) {
            return false
        }
        return (0, _type.isDefined)(__allowedDirection())
    }), [props.scrollByContent, props.bounceEnabled, props.direction]);
    var __onWidgetKeyDown = (0, _hooks.useCallback)((function(options) {
        var onKeyDown = props.onKeyDown;
        var originalEvent = options.originalEvent;
        var result = null === onKeyDown || void 0 === onKeyDown ? void 0 : onKeyDown(options);
        if (null !== result && void 0 !== result && result.cancel) {
            return result
        }
        __keyDownHandler(originalEvent);
        return
    }), [props.onKeyDown, props.direction, props.rtlEnabled]);
    var __keyDownHandler = (0, _hooks.useCallback)((function(e) {
        var handled = true;
        switch ((0, _index.normalizeKeyName)(e)) {
            case KEY_CODES.DOWN:
                __scrollByLine({
                    y: 1
                });
                break;
            case KEY_CODES.UP:
                __scrollByLine({
                    y: -1
                });
                break;
            case KEY_CODES.RIGHT:
                __scrollByLine({
                    x: 1
                });
                break;
            case KEY_CODES.LEFT:
                __scrollByLine({
                    x: -1
                });
                break;
            case KEY_CODES.PAGE_DOWN:
                __scrollByPage(1);
                break;
            case KEY_CODES.PAGE_UP:
                __scrollByPage(-1);
                break;
            case KEY_CODES.HOME:
                __scrollToHome();
                break;
            case KEY_CODES.END:
                __scrollToEnd();
                break;
            default:
                handled = false
        }
        if (handled) {
            e.stopPropagation();
            e.preventDefault()
        }
    }), [props.direction, props.rtlEnabled]);
    var __scrollByLine = (0, _hooks.useCallback)((function(lines) {
        var devicePixelRatio = __tryGetDevicePixelRatio();
        var scrollOffset = _scrollable_utils.SCROLL_LINE_HEIGHT;
        if (devicePixelRatio) {
            scrollOffset = Math.abs(scrollOffset / devicePixelRatio * 100) / 100
        }
        __scrollBy({
            top: (lines.y || 0) * scrollOffset,
            left: (lines.x || 0) * scrollOffset
        })
    }), [props.direction, props.rtlEnabled]);
    var __tryGetDevicePixelRatio = (0, _hooks.useCallback)((function() {
        if ((0, _window.hasWindow)()) {
            return (0, _window.getWindow)().devicePixelRatio
        }
        return
    }), []);
    var __scrollByPage = (0, _hooks.useCallback)((function(page) {
        var prop = __wheelProp();
        var distance = {};
        if ("width" === __getDimensionByProp(prop)) {
            distance[prop] = page * (0, _scrollable_utils.getElementWidth)(__containerRef.current)
        } else {
            distance[prop] = page * (0, _scrollable_utils.getElementHeight)(__containerRef.current)
        }
        __scrollBy(distance)
    }), [props.direction, props.rtlEnabled]);
    var __wheelProp = (0, _hooks.useCallback)((function() {
        return __wheelDirection() === _scrollable_utils.DIRECTION_HORIZONTAL ? "left" : "top"
    }), [props.direction]);
    var __wheelDirection = (0, _hooks.useCallback)((function(e) {
        switch (props.direction) {
            case _scrollable_utils.DIRECTION_HORIZONTAL:
                return _scrollable_utils.DIRECTION_HORIZONTAL;
            case _scrollable_utils.DIRECTION_VERTICAL:
                return _scrollable_utils.DIRECTION_VERTICAL;
            default:
                return null !== e && void 0 !== e && e.shiftKey ? _scrollable_utils.DIRECTION_HORIZONTAL : _scrollable_utils.DIRECTION_VERTICAL
        }
    }), [props.direction]);
    var __scrollToHome = (0, _hooks.useCallback)((function() {
        var prop = __wheelProp();
        var distance = {};
        distance[prop] = 0;
        __scrollTo(distance)
    }), [props.direction, props.rtlEnabled]);
    var __scrollToEnd = (0, _hooks.useCallback)((function() {
        var prop = __wheelProp();
        var distance = {};
        if ("width" === __getDimensionByProp(prop)) {
            distance[prop] = (0, _scrollable_utils.getElementWidth)(__contentRef.current) - (0, _scrollable_utils.getElementWidth)(__containerRef.current)
        } else {
            distance[prop] = (0, _scrollable_utils.getElementHeight)(__contentRef.current) - (0, _scrollable_utils.getElementHeight)(__containerRef.current)
        }
        __scrollTo(distance)
    }), [props.direction, props.rtlEnabled]);
    var __getDimensionByProp = (0, _hooks.useCallback)((function(prop) {
        return "left" === prop ? "width" : "height"
    }), []);
    var __isHoverMode = (0, _hooks.useCallback)((function() {
        return "onHover" === props.showScrollbar
    }), [props.showScrollbar]);
    var __isScrollbarVisible = (0, _hooks.useCallback)((function() {
        return __adjustVisibility()
    }), [props.showScrollbar, __state_isHovered]);
    var __adjustVisibility = (0, _hooks.useCallback)((function() {
        var showScrollbar = props.showScrollbar;
        if ("never" === showScrollbar) {
            return false
        }
        if ("onHover" === showScrollbar) {
            return __state_isHovered
        }
        if ("onScroll" === showScrollbar) {
            return false
        }
        if ("always" === showScrollbar) {
            return true
        }
        return false
    }), [props.showScrollbar, __state_isHovered]);
    var __cssClasses = (0, _hooks.useCallback)((function() {
        var _classesMap;
        var classes = props.classes,
            direction = props.direction,
            disabled = props.disabled,
            showScrollbar = props.showScrollbar;
        var classesMap = (_classesMap = {
            "dx-scrollable dx-scrollable-renovated": true
        }, _defineProperty(_classesMap, _scrollable_utils.SCROLLABLE_SIMULATED_CLASS, true), _defineProperty(_classesMap, "dx-scrollable-".concat(direction), true), _defineProperty(_classesMap, _scrollable_utils.SCROLLABLE_DISABLED_CLASS, !!disabled), _defineProperty(_classesMap, _scrollable_utils.SCROLLABLE_SCROLLBARS_ALWAYSVISIBLE, "always" === showScrollbar), _defineProperty(_classesMap, _scrollable_utils.SCROLLABLE_SCROLLBARS_HIDDEN, !showScrollbar), _defineProperty(_classesMap, "".concat(classes), !!classes), _classesMap);
        return (0, _combine_classes.combineClasses)(classesMap)
    }), [props.classes, props.direction, props.disabled, props.showScrollbar]);
    var __restAttributes = (0, _hooks.useCallback)((function() {
        props.bounceEnabled, props.children, props.classes, props.direction, props.disabled, props.forceGeneratePockets, props.height, props.inertiaEnabled, props.needScrollViewContentWrapper, props.onBounce, props.onEnd, props.onKeyDown, props.onScroll, props.onStart, props.onStop, props.onUpdated, props.pulledDownText, props.pullingDownText, props.reachBottomText, props.refreshingText, props.rtlEnabled, props.scrollByContent, props.scrollByThumb, props.showScrollbar, props.updateManually, props.useKeyboard, props.useNative, props.useSimulatedScrollbar, props.visible, props.width;
        var restProps = _objectWithoutProperties(props, ["bounceEnabled", "children", "classes", "direction", "disabled", "forceGeneratePockets", "height", "inertiaEnabled", "needScrollViewContentWrapper", "onBounce", "onEnd", "onKeyDown", "onScroll", "onStart", "onStop", "onUpdated", "pulledDownText", "pullingDownText", "reachBottomText", "refreshingText", "rtlEnabled", "scrollByContent", "scrollByThumb", "showScrollbar", "updateManually", "useKeyboard", "useNative", "useSimulatedScrollbar", "visible", "width"]);
        return restProps
    }), [props]);
    var __content = (0, _hooks.useCallback)((function() {
        return __contentRef.current
    }), []);
    var __scrollBy = (0, _hooks.useCallback)((function(distance) {
        var location = (0, _scrollable_utils.ensureLocation)(distance);
        var _ScrollDirection5 = new _scrollable_utils.ScrollDirection(props.direction),
            isHorizontal = _ScrollDirection5.isHorizontal,
            isVertical = _ScrollDirection5.isVertical;
        if (isVertical) {
            __containerRef.current.scrollTop += Math.round(location.top)
        }
        if (isHorizontal) {
            __containerRef.current.scrollLeft += (0, _scrollable_utils.normalizeCoordinate)("left", Math.round(location.left), props.rtlEnabled)
        }
    }), [props.direction, props.rtlEnabled]);
    var __scrollTo = (0, _hooks.useCallback)((function(targetLocation) {
        var location = (0, _scrollable_utils.ensureLocation)(targetLocation);
        var containerPosition = __scrollOffset();
        var top = location.top - containerPosition.top;
        var left = location.left - containerPosition.left;
        __scrollBy({
            top: top,
            left: left
        })
    }), [props.rtlEnabled, props.direction]);
    var __scrollToElement = (0, _hooks.useCallback)((function(element, offset) {
        if (void 0 === element || null === element) {
            return
        }
        if (element.closest(".".concat(_scrollable_utils.SCROLLABLE_CONTENT_CLASS))) {
            var scrollOffset = _objectSpread({
                top: 0,
                left: 0,
                right: 0,
                bottom: 0
            }, offset);
            __scrollTo({
                top: (0, _scrollable_utils.getElementLocation)(element, scrollOffset, _scrollable_utils.DIRECTION_VERTICAL, __containerRef.current, props.rtlEnabled),
                left: (0, _scrollable_utils.getElementLocation)(element, scrollOffset, _scrollable_utils.DIRECTION_HORIZONTAL, __containerRef.current, props.rtlEnabled)
            })
        }
    }), [props.rtlEnabled, props.direction]);
    var __scrollHeight = (0, _hooks.useCallback)((function() {
        return __content().offsetHeight
    }), []);
    var __scrollWidth = (0, _hooks.useCallback)((function() {
        return __content().offsetWidth
    }), []);
    var __scrollOffset = (0, _hooks.useCallback)((function() {
        var rtlEnabled = props.rtlEnabled;
        var _getContainerOffsetIn = (0, _scrollable_utils.getContainerOffsetInternal)(__containerRef.current),
            left = _getContainerOffsetIn.left,
            top = _getContainerOffsetIn.top;
        return {
            left: (0, _scrollable_utils.getPublicCoordinate)("left", left, __containerRef.current, rtlEnabled),
            top: (0, _scrollable_utils.getPublicCoordinate)("top", top, __containerRef.current, rtlEnabled)
        }
    }), [props.rtlEnabled]);
    var __scrollTop = (0, _hooks.useCallback)((function() {
        return __scrollOffset().top
    }), [props.rtlEnabled]);
    var __scrollLeft = (0, _hooks.useCallback)((function() {
        return __scrollOffset().left
    }), [props.rtlEnabled]);
    var __clientHeight = (0, _hooks.useCallback)((function() {
        return __containerRef.current.clientHeight
    }), []);
    var __clientWidth = (0, _hooks.useCallback)((function() {
        return __containerRef.current.clientWidth
    }), []);
    (0, _hooks.useEffect)((function() {
        return function() {
            return __clearWheelValidationTimer()
        }
    }), []);
    (0, _hooks.useEffect)((function() {
        return (0, _subscribe_to_event.subscribeToScrollEvent)(__containerRef.current, (function() {
            var _props$onScroll;
            return null === (_props$onScroll = props.onScroll) || void 0 === _props$onScroll ? void 0 : _props$onScroll.call(props, __getEventArgs())
        }))
    }), [props.onScroll, __state_cachedVariables, props.rtlEnabled, props.direction]);
    (0, _hooks.useEffect)((function() {
        _short.dxScrollInit.on(__wrapperRef.current, (function(e) {
            __handleInit(e)
        }), {
            getDirection: function(e) {
                return __getDirection(e)
            },
            validate: function(e) {
                return __validate(e)
            },
            isNative: false,
            scrollTarget: __containerRef.current
        }, {
            namespace: "dxScrollable"
        });
        return function() {
            return _short.dxScrollInit.off(__wrapperRef.current, {
                namespace: "dxScrollable"
            })
        }
    }), [props.direction, props.scrollByContent, props.scrollByThumb, props.onStop, props.bounceEnabled, __state_cachedVariables, props.disabled]);
    (0, _hooks.useEffect)((function() {
        _short.dxScrollStart.on(__wrapperRef.current, (function(e) {
            __handleStart(e)
        }), {
            namespace: "dxScrollable"
        });
        return function() {
            return _short.dxScrollStart.off(__wrapperRef.current, {
                namespace: "dxScrollable"
            })
        }
    }), []);
    (0, _hooks.useEffect)((function() {
        _short.dxScrollMove.on(__wrapperRef.current, (function(e) {
            __handleMove(e)
        }), {
            namespace: "dxScrollable"
        });
        return function() {
            return _short.dxScrollMove.off(__wrapperRef.current, {
                namespace: "dxScrollable"
            })
        }
    }), [__state_validDirections, props.direction]);
    (0, _hooks.useEffect)((function() {
        _short.dxScrollEnd.on(__wrapperRef.current, (function(e) {
            __handleEnd(e)
        }), {
            namespace: "dxScrollable"
        });
        return function() {
            return _short.dxScrollEnd.off(__wrapperRef.current, {
                namespace: "dxScrollable"
            })
        }
    }), [__state_validDirections, props.direction, props.onEnd]);
    (0, _hooks.useEffect)((function() {
        _short.dxScrollStop.on(__wrapperRef.current, (function() {
            __handleStop()
        }), {
            namespace: "dxScrollable"
        });
        return function() {
            return _short.dxScrollStop.off(__wrapperRef.current, {
                namespace: "dxScrollable"
            })
        }
    }), [props.direction]);
    (0, _hooks.useEffect)((function() {
        _short.dxScrollCancel.on(__wrapperRef.current, (function(event) {
            __handleCancel(event)
        }), {
            namespace: "dxScrollable"
        });
        return function() {
            return _short.dxScrollCancel.off(__wrapperRef.current, {
                namespace: "dxScrollable"
            })
        }
    }), []);
    (0, _hooks.useEffect)((function() {
        var scrollableOffset = (0, _renderer.default)(__scrollableRef.current).offset() || {
            left: 0,
            top: 0
        };
        __state_setScaleRatioWidth((function(__state_scaleRatioWidth) {
            return __getScaleRatio("width")
        }));
        __state_setContentWidth((function(__state_contentWidth) {
            return __contentSize("width")
        }));
        __state_setContainerWidth((function(__state_containerWidth) {
            return __containerSize("width")
        }));
        __state_setBaseContentWidth((function(__state_baseContentWidth) {
            return Math.round(__getBaseDimension(__contentRef.current, "width"))
        }));
        __state_setBaseContainerWidth((function(__state_baseContainerWidth) {
            return Math.round(__getBaseDimension(__containerRef.current, "width"))
        }));
        __state_setScrollableOffsetLeft((function(__state_scrollableOffsetLeft) {
            return scrollableOffset.left
        }));
        __state_setScaleRatioHeight((function(__state_scaleRatioHeight) {
            return __getScaleRatio("height")
        }));
        __state_setContentHeight((function(__state_contentHeight) {
            return __contentSize("height")
        }));
        __state_setContainerHeight((function(__state_containerHeight) {
            return __containerSize("height")
        }));
        __state_setBaseContentHeight((function(__state_baseContentHeight) {
            return Math.round(__getBaseDimension(__contentRef.current, "height"))
        }));
        __state_setBaseContainerHeight((function(__state_baseContainerHeight) {
            return Math.round(__getBaseDimension(__containerRef.current, "height"))
        }));
        __state_setScrollableOffsetTop((function(__state_scrollableOffsetTop) {
            return scrollableOffset.top
        }))
    }), [__state_isHovered, __state_scaleRatioWidth, __state_scaleRatioHeight, __state_scrollableOffsetLeft, __state_scrollableOffsetTop, __state_contentWidth, __state_contentHeight, __state_containerWidth, __state_containerHeight, __state_baseContentWidth, __state_baseContentHeight, __state_baseContainerWidth, __state_baseContainerHeight, __state_validDirections, __state_cachedVariables, props.inertiaEnabled, props.onStart, props.onEnd, props.onBounce, props.onStop, props.useNative, props.pullingDownText, props.pulledDownText, props.refreshingText, props.reachBottomText, props.children, props.direction, props.showScrollbar, props.scrollByThumb, props.useSimulatedScrollbar, props.bounceEnabled, props.scrollByContent, props.updateManually, props.useKeyboard, props.classes, props.forceGeneratePockets, props.needScrollViewContentWrapper, props.onScroll, props.onUpdated, props.disabled, props.height, props.onKeyDown, props.rtlEnabled, props.visible, props.width]);
    (0, _hooks.useImperativeHandle)(ref, (function() {
        return {
            content: __content,
            scrollBy: __scrollBy,
            scrollTo: __scrollTo,
            scrollToElement: __scrollToElement,
            scrollHeight: __scrollHeight,
            scrollWidth: __scrollWidth,
            scrollOffset: __scrollOffset,
            scrollTop: __scrollTop,
            scrollLeft: __scrollLeft,
            clientHeight: __clientHeight,
            clientWidth: __clientWidth
        }
    }), [__content, __scrollBy, __scrollTo, __scrollToElement, __scrollHeight, __scrollWidth, __scrollOffset, __scrollTop, __scrollLeft, __clientHeight, __clientWidth]);
    return viewFunction({
        props: _objectSpread({}, props),
        isHovered: __state_isHovered,
        scaleRatioWidth: __state_scaleRatioWidth,
        scaleRatioHeight: __state_scaleRatioHeight,
        scrollableOffsetLeft: __state_scrollableOffsetLeft,
        scrollableOffsetTop: __state_scrollableOffsetTop,
        contentWidth: __state_contentWidth,
        contentHeight: __state_contentHeight,
        containerWidth: __state_containerWidth,
        containerHeight: __state_containerHeight,
        baseContentWidth: __state_baseContentWidth,
        baseContentHeight: __state_baseContentHeight,
        baseContainerWidth: __state_baseContainerWidth,
        baseContainerHeight: __state_baseContainerHeight,
        validDirections: __state_validDirections,
        cachedVariables: __state_cachedVariables,
        scrollableRef: __scrollableRef,
        wrapperRef: __wrapperRef,
        contentRef: __contentRef,
        containerRef: __containerRef,
        verticalScrollbarRef: __verticalScrollbarRef,
        horizontalScrollbarRef: __horizontalScrollbarRef,
        getEventArgs: __getEventArgs,
        cursorEnterHandler: __cursorEnterHandler,
        cursorLeaveHandler: __cursorLeaveHandler,
        handleInit: __handleInit,
        isThumbScrolling: __isThumbScrolling,
        adjustDistance: __adjustDistance,
        suppressDirections: __suppressDirections,
        validateEvent: __validateEvent,
        prepareDirections: __prepareDirections,
        isContent: __isContent,
        eventHandler: __eventHandler,
        containerSize: __containerSize,
        getRealDimension: __getRealDimension,
        getBaseDimension: __getBaseDimension,
        contentSize: __contentSize,
        getScaleRatio: __getScaleRatio,
        onWidgetKeyDown: __onWidgetKeyDown,
        scrollByLine: __scrollByLine,
        tryGetDevicePixelRatio: __tryGetDevicePixelRatio,
        scrollByPage: __scrollByPage,
        scrollToHome: __scrollToHome,
        scrollToEnd: __scrollToEnd,
        isScrollbarVisible: __isScrollbarVisible(),
        adjustVisibility: __adjustVisibility,
        cssClasses: __cssClasses(),
        restAttributes: __restAttributes()
    })
}));
exports.ScrollableSimulated = ScrollableSimulated;
ScrollableSimulated.defaultProps = _objectSpread({}, _scrollable_simulated_props.ScrollableSimulatedPropsType);
