/**
 * DevExtreme (renovation/ui/scroll_view/scrollbar.js)
 * Version: 21.1.0 (build 21032-0316)
 * Build date: Mon Feb 01 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.Scrollbar = exports.viewFunction = void 0;
var _widget = require("../common/widget");
var _combine_classes = require("../../utils/combine_classes");
var _dom_adapter = _interopRequireDefault(require("../../../core/dom_adapter"));
var _type = require("../../../core/utils/type");
var _translator = require("../../../animation/translator");
var _index = require("../../../events/utils/index");
var _deferred = require("../../../core/utils/deferred");
var _inflector = require("../../../core/utils/inflector");
var _scrollbar_props = require("./scrollbar_props");
var _scrollable_utils = require("./scrollable_utils");
var _short = require("../../../events/short");
var _base_props = _interopRequireDefault(require("../../utils/base_props"));
var Preact = _interopRequireWildcard(require("preact"));
var _hooks = require("preact/hooks");
var _compat = require("preact/compat");

function _getRequireWildcardCache() {
    if ("function" !== typeof WeakMap) {
        return null
    }
    var cache = new WeakMap;
    _getRequireWildcardCache = function() {
        return cache
    };
    return cache
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    }
    if (null === obj || "object" !== _typeof(obj) && "function" !== typeof obj) {
        return {
            default: obj
        }
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj)
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc)
            } else {
                newObj[key] = obj[key]
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj)
    }
    return newObj
}

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter((function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            }))
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach((function(key) {
                _defineProperty(target, key, source[key])
            }))
        } else if (Object.getOwnPropertyDescriptors) {
            Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
        } else {
            ownKeys(Object(source)).forEach((function(key) {
                Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
            }))
        }
    }
    return target
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}

function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest()
}

function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")
}

function _unsupportedIterableToArray(o, minLen) {
    if (!o) {
        return
    }
    if ("string" === typeof o) {
        return _arrayLikeToArray(o, minLen)
    }
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if ("Object" === n && o.constructor) {
        n = o.constructor.name
    }
    if ("Map" === n || "Set" === n) {
        return Array.from(o)
    }
    if ("Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) {
        return _arrayLikeToArray(o, minLen)
    }
}

function _arrayLikeToArray(arr, len) {
    if (null == len || len > arr.length) {
        len = arr.length
    }
    for (var i = 0, arr2 = new Array(len); i < len; i++) {
        arr2[i] = arr[i]
    }
    return arr2
}

function _iterableToArrayLimit(arr, i) {
    if ("undefined" === typeof Symbol || !(Symbol.iterator in Object(arr))) {
        return
    }
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = void 0;
    try {
        for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done); _n = true) {
            _arr.push(_s.value);
            if (i && _arr.length === i) {
                break
            }
        }
    } catch (err) {
        _d = true;
        _e = err
    } finally {
        try {
            if (!_n && null != _i.return) {
                _i.return()
            }
        } finally {
            if (_d) {
                throw _e
            }
        }
    }
    return _arr
}

function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) {
        return arr
    }
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}
var OUT_BOUNDS_ACCELERATION = .5;
var SCROLLABLE_SCROLLBAR_ACTIVE_CLASS = "dx-scrollable-scrollbar-active";
var SCROLLABLE_SCROLL_CLASS = "dx-scrollable-scroll";
var SCROLLABLE_SCROLL_CONTENT_CLASS = "dx-scrollable-scroll-content";
var HOVER_ENABLED_STATE = "dx-scrollbar-hoverable";
var THUMB_MIN_SIZE = 15;
var viewFunction = function(viewModel) {
    var cssClasses = viewModel.cssClasses,
        hoverStateEnabled = viewModel.hoverStateEnabled,
        isVisible = viewModel.isVisible,
        activeStateEnabled = viewModel.props.activeStateEnabled,
        restAttributes = viewModel.restAttributes,
        scrollRef = viewModel.scrollRef,
        scrollbarRef = viewModel.scrollbarRef,
        styles = viewModel.styles;
    return Preact.h(_widget.Widget, _extends({
        rootElementRef: scrollbarRef,
        classes: cssClasses,
        activeStateEnabled: activeStateEnabled,
        hoverStateEnabled: hoverStateEnabled,
        visible: isVisible
    }, restAttributes), Preact.h("div", {
        className: viewModel.scrollClasses,
        style: styles,
        ref: scrollRef
    }, Preact.h("div", {
        className: SCROLLABLE_SCROLL_CONTENT_CLASS
    })))
};
exports.viewFunction = viewFunction;
var ScrollbarPropsType = {
    activeStateEnabled: _scrollbar_props.ScrollbarProps.activeStateEnabled,
    expandable: _scrollbar_props.ScrollbarProps.expandable,
    direction: _scrollbar_props.ScrollbarProps.direction,
    scaleRatio: _scrollbar_props.ScrollbarProps.scaleRatio,
    containerSize: _scrollbar_props.ScrollbarProps.containerSize,
    contentSize: _scrollbar_props.ScrollbarProps.contentSize,
    baseContainerSize: _scrollbar_props.ScrollbarProps.baseContainerSize,
    baseContentSize: _scrollbar_props.ScrollbarProps.baseContentSize,
    scrollableOffset: _scrollbar_props.ScrollbarProps.scrollableOffset,
    bounceEnabled: _scrollbar_props.ScrollbarProps.bounceEnabled,
    inertiaEnabled: _scrollbar_props.ScrollbarProps.inertiaEnabled,
    scrollByThumb: _scrollbar_props.ScrollbarProps.scrollByThumb,
    scrollScrollbar: _scrollbar_props.ScrollbarProps.scrollScrollbar,
    showScrollbar: _scrollbar_props.ScrollbarProps.showScrollbar,
    useSimulatedScrollbar: _scrollbar_props.ScrollbarProps.useSimulatedScrollbar,
    scrollByContent: _scrollbar_props.ScrollbarProps.scrollByContent,
    updateManually: _scrollbar_props.ScrollbarProps.updateManually,
    useKeyboard: _scrollbar_props.ScrollbarProps.useKeyboard,
    forceGeneratePockets: _scrollbar_props.ScrollbarProps.forceGeneratePockets,
    needScrollViewContentWrapper: _scrollbar_props.ScrollbarProps.needScrollViewContentWrapper,
    visible: _base_props.default.visible
};
var Scrollbar = (0, _compat.forwardRef)((function(props, ref) {
    var __scrollbarRef = (0, _hooks.useRef)();
    var __scrollRef = (0, _hooks.useRef)();
    var _useState = (0, _hooks.useState)(false),
        _useState2 = _slicedToArray(_useState, 2),
        __state_active = _useState2[0],
        __state_setActive = _useState2[1];
    var _useState3 = (0, _hooks.useState)({
            location: 0,
            velocity: 0,
            thumbScrolling: false,
            crossThumbScrolling: false,
            translateOffset: void 0
        }),
        _useState4 = _slicedToArray(_useState3, 2),
        __state_cachedVariables = _useState4[0];
    _useState4[1];
    var __calculateScrollBarPosition = (0, _hooks.useCallback)((function(location) {
        return -location * __thumbRatio()
    }), [props.containerSize, props.contentSize, props.scaleRatio]);
    var __inBounds = (0, _hooks.useCallback)((function() {
        var location = __getLocation();
        return __boundLocation(location) === location
    }), [__state_cachedVariables, props.contentSize, props.containerSize]);
    var __boundLocation = (0, _hooks.useCallback)((function(location) {
        var currentLocation = void 0 !== location ? location : __getLocation();
        return Math.max(Math.min(currentLocation, __getMaxOffset()), __getMinOffset())
    }), [__state_cachedVariables, props.contentSize, props.containerSize]);
    var __getMaxOffset = (0, _hooks.useCallback)((function() {
        return 0
    }), []);
    var __getAxis = (0, _hooks.useCallback)((function() {
        return props.direction === _scrollable_utils.DIRECTION_HORIZONTAL ? "x" : "y"
    }), [props.direction]);
    var __getProp = (0, _hooks.useCallback)((function() {
        return props.direction === _scrollable_utils.DIRECTION_HORIZONTAL ? "left" : "top"
    }), [props.direction]);
    var __inertiaHandler = (0, _hooks.useCallback)((function() {
        __suppressInertia()
    }), [props.inertiaEnabled, __state_cachedVariables]);
    var __suppressInertia = (0, _hooks.useCallback)((function() {
        if (!props.inertiaEnabled || __state_cachedVariables.thumbScrolling) {
            __state_cachedVariables.velocity = 0
        }
    }), [props.inertiaEnabled, __state_cachedVariables]);
    var __resetThumbScrolling = (0, _hooks.useCallback)((function() {
        __state_cachedVariables.thumbScrolling = false;
        __state_cachedVariables.crossThumbScrolling = false
    }), []);
    var __scrollBy = (0, _hooks.useCallback)((function(delta) {
        var distance = delta[__getAxis()];
        if (!__inBounds()) {
            distance *= OUT_BOUNDS_ACCELERATION
        }
        __scrollStep(distance)
    }), [props.direction, __state_cachedVariables, props.contentSize, props.containerSize, props.bounceEnabled, props.scaleRatio, props.containerRef, props.showScrollbar]);
    var __prepareThumbScrolling = (0, _hooks.useCallback)((function(e, crossThumbScrolling) {
        if ((0, _index.isDxMouseWheelEvent)(e.originalEvent)) {
            return
        }
        var target = e.originalEvent.target;
        var scrollByThumb = props.scrollByThumb;
        var scrollbarClicked = scrollByThumb && __isScrollbar(target);
        if (scrollbarClicked) {
            __moveToMouseLocation(e)
        }
        var thumbScrolling = scrollbarClicked || scrollByThumb && __isThumb(target);
        __state_cachedVariables.thumbScrolling = thumbScrolling;
        __state_cachedVariables.crossThumbScrolling = !thumbScrolling && crossThumbScrolling;
        if (thumbScrolling) {
            __feedbackOn()
        }
    }), [props.scrollByThumb, props.scrollableOffset, props.direction, __state_cachedVariables, props.containerSize, props.contentSize, props.containerRef, props.bounceEnabled, props.scaleRatio, props.showScrollbar]);
    var __moveToMouseLocation = (0, _hooks.useCallback)((function(e) {
        var scrollableOffset = props.scrollableOffset;
        var mouseLocation = e["page".concat(__getAxis().toUpperCase())] - scrollableOffset;
        var location = __getLocation() + mouseLocation / __containerToContentRatio() - (0, _scrollable_utils.getElementHeight)(__getContainerRef().current) / 2;
        __scrollStep(-Math.round(location))
    }), [props.scrollableOffset, props.direction, __state_cachedVariables, props.containerSize, props.contentSize, props.containerRef, props.bounceEnabled, props.scaleRatio, props.showScrollbar]);
    var __scrollStep = (0, _hooks.useCallback)((function(delta) {
        var prevLocation = __getLocation();
        __setLocation(prevLocation + delta);
        __suppressBounce();
        __move();
        if (Math.abs(prevLocation - __getLocation()) < 1) {
            return
        }
    }), [__state_cachedVariables, props.bounceEnabled, props.contentSize, props.containerSize, props.scaleRatio, props.containerRef, props.showScrollbar, props.direction]);
    var __getContainerRef = (0, _hooks.useCallback)((function() {
        return props.containerRef
    }), [props.containerRef]);
    var __suppressBounce = (0, _hooks.useCallback)((function() {
        if (props.bounceEnabled || __inBounds()) {
            return
        }
        __state_cachedVariables.velocity = 0;
        var boundLocation = __boundLocation();
        __setLocation(boundLocation)
    }), [props.bounceEnabled, __state_cachedVariables, props.contentSize, props.containerSize]);
    var __move = (0, _hooks.useCallback)((function(location) {
        var currentLocation = void 0 !== location ? location * props.scaleRatio : __getLocation();
        __setLocation(currentLocation);
        __moveContent();
        __moveTo(__getLocation())
    }), [props.scaleRatio, __state_cachedVariables, props.contentSize, props.containerSize, props.containerRef, props.showScrollbar, props.direction]);
    var __moveContent = (0, _hooks.useCallback)((function() {
        var location = __getLocation();
        __getContainerRef().current["scroll".concat((0, _inflector.titleize)(__getProp()))] = -location / props.scaleRatio;
        __moveContentByTranslator(location)
    }), [__state_cachedVariables, props.scaleRatio, props.contentSize, props.containerSize, props.containerRef]);
    var __moveContentByTranslator = (0, _hooks.useCallback)((function(location) {
        var translateOffset;
        var minOffset = __getMinOffset();
        if (location > 0) {
            translateOffset = location
        } else if (location <= minOffset) {
            translateOffset = location - minOffset
        } else {
            translateOffset = location % 1
        }
        if (__state_cachedVariables.translateOffset === translateOffset) {
            return
        }
        var targetLocation = {};
        targetLocation[__getProp()] = translateOffset;
        __state_cachedVariables.translateOffset = translateOffset;
        if (0 === translateOffset) {
            (0, _translator.resetPosition)(__getContainerRef().current);
            return
        }(0, _translator.move)(__getContainerRef().current, targetLocation)
    }), [props.contentSize, props.containerSize, __state_cachedVariables, props.containerRef]);
    var __thumbSize = (0, _hooks.useCallback)((function() {
        var containerSize = props.containerSize,
            scaleRatio = props.scaleRatio;
        var size = Math.round(Math.max(Math.round(containerSize * __containerToContentRatio()), THUMB_MIN_SIZE));
        return size / scaleRatio
    }), [props.containerSize, props.scaleRatio, props.contentSize]);
    var __thumbRatio = (0, _hooks.useCallback)((function() {
        var containerSize = props.containerSize,
            contentSize = props.contentSize,
            scaleRatio = props.scaleRatio;
        return (containerSize - __thumbSize()) / (scaleRatio * (contentSize - containerSize))
    }), [props.containerSize, props.contentSize, props.scaleRatio]);
    var __containerToContentRatio = (0, _hooks.useCallback)((function() {
        var containerSize = props.containerSize,
            contentSize = props.contentSize;
        return contentSize ? containerSize / contentSize : containerSize
    }), [props.containerSize, props.contentSize]);
    var __baseContainerToContentRatio = (0, _hooks.useCallback)((function() {
        var baseContainerSize = props.baseContainerSize,
            baseContentSize = props.baseContentSize;
        return baseContentSize ? baseContainerSize / baseContentSize : baseContainerSize
    }), [props.baseContainerSize, props.baseContentSize]);
    var __getDimension = (0, _hooks.useCallback)((function() {
        return props.direction === _scrollable_utils.DIRECTION_HORIZONTAL ? "width" : "height"
    }), [props.direction]);
    var __feedbackOn = (0, _hooks.useCallback)((function() {
        __state_setActive((function(__state_active) {
            return true
        }))
    }), []);
    var __feedbackOff = (0, _hooks.useCallback)((function() {
        __state_setActive((function(__state_active) {
            return false
        }))
    }), []);
    var __cssClasses = (0, _hooks.useCallback)((function() {
        var _classesMap;
        var direction = props.direction;
        var classesMap = (_classesMap = {}, _defineProperty(_classesMap, _scrollable_utils.SCROLLABLE_SCROLLBAR_CLASS, true), _defineProperty(_classesMap, "dx-scrollbar-".concat(direction), true), _defineProperty(_classesMap, SCROLLABLE_SCROLLBAR_ACTIVE_CLASS, !!__state_active), _defineProperty(_classesMap, HOVER_ENABLED_STATE, !!__hoverStateEnabled()), _classesMap);
        return (0, _combine_classes.combineClasses)(classesMap)
    }), [props.direction, __state_active, props.scrollByThumb, props.showScrollbar]);
    var __styles = (0, _hooks.useCallback)((function() {
        var style = __restAttributes().style || {};
        return _objectSpread(_objectSpread({}, style), {}, _defineProperty({}, __getDimension(), __thumbSize() || THUMB_MIN_SIZE))
    }), [props, props.direction, props.containerSize, props.scaleRatio, props.contentSize]);
    var __scrollClasses = (0, _hooks.useCallback)((function() {
        var _combineClasses;
        return (0, _combine_classes.combineClasses)((_combineClasses = {}, _defineProperty(_combineClasses, SCROLLABLE_SCROLL_CLASS, true), _defineProperty(_combineClasses, "dx-state-invisible", !(props.visible && __baseContainerToContentRatio() < 1)), _combineClasses))
    }), [props.visible, props.baseContainerSize, props.baseContentSize]);
    var __isVisible = (0, _hooks.useCallback)((function() {
        return "never" !== props.showScrollbar && __baseContainerToContentRatio() < 1
    }), [props.showScrollbar, props.baseContainerSize, props.baseContentSize]);
    var __hoverStateEnabled = (0, _hooks.useCallback)((function() {
        var scrollByThumb = props.scrollByThumb,
            showScrollbar = props.showScrollbar;
        return ("onHover" === showScrollbar || "always" === showScrollbar) && scrollByThumb
    }), [props.scrollByThumb, props.showScrollbar]);
    var __restAttributes = (0, _hooks.useCallback)((function() {
        props.activeStateEnabled, props.baseContainerSize, props.baseContentSize, props.bounceEnabled, props.children, props.classes, props.containerRef, props.containerSize, props.contentRef, props.contentSize, props.direction, props.expandable, props.forceGeneratePockets, props.hoverStateEnabled, props.inertiaEnabled, props.needScrollViewContentWrapper, props.onScroll, props.onUpdated, props.scaleRatio, props.scrollByContent, props.scrollByThumb, props.scrollScrollbar, props.scrollableOffset, props.showScrollbar, props.updateManually, props.useKeyboard, props.useSimulatedScrollbar, props.visible;
        var restProps = _objectWithoutProperties(props, ["activeStateEnabled", "baseContainerSize", "baseContentSize", "bounceEnabled", "children", "classes", "containerRef", "containerSize", "contentRef", "contentSize", "direction", "expandable", "forceGeneratePockets", "hoverStateEnabled", "inertiaEnabled", "needScrollViewContentWrapper", "onScroll", "onUpdated", "scaleRatio", "scrollByContent", "scrollByThumb", "scrollScrollbar", "scrollableOffset", "showScrollbar", "updateManually", "useKeyboard", "useSimulatedScrollbar", "visible"]);
        return restProps
    }), [props]);
    var __moveTo = (0, _hooks.useCallback)((function(location) {
        var showScrollbar = props.showScrollbar;
        if ("never" === showScrollbar) {
            return
        }
        var position = location;
        var prop = props.direction === _scrollable_utils.DIRECTION_HORIZONTAL ? "left" : "top";
        if ((0, _type.isPlainObject)(location)) {
            position = location[prop] || 0
        }
        var scrollBarLocation = {};
        scrollBarLocation[prop] = __calculateScrollBarPosition(position);
        (0, _translator.move)(__scrollRef.current, scrollBarLocation)
    }), [props.showScrollbar, props.direction, props.containerSize, props.contentSize, props.scaleRatio]);
    var __isThumb = (0, _hooks.useCallback)((function(element) {
        return __scrollbarRef.current.querySelector(".".concat(SCROLLABLE_SCROLL_CLASS)) === element || __scrollbarRef.current.querySelector(".".concat(SCROLLABLE_SCROLL_CONTENT_CLASS)) === element
    }), []);
    var __isScrollbar = (0, _hooks.useCallback)((function(element) {
        return element === __scrollbarRef.current
    }), []);
    var __validateEvent = (0, _hooks.useCallback)((function(event) {
        var target = event.originalEvent.target;
        return __isThumb(target) || __isScrollbar(target)
    }), []);
    var __reachedMin = (0, _hooks.useCallback)((function() {
        return __getLocation() <= __getMinOffset()
    }), [__state_cachedVariables, props.contentSize, props.containerSize]);
    var __reachedMax = (0, _hooks.useCallback)((function() {
        return __getLocation() >= __getMaxOffset()
    }), [__state_cachedVariables]);
    var __getLocation = (0, _hooks.useCallback)((function() {
        return __state_cachedVariables.location
    }), [__state_cachedVariables]);
    var __setLocation = (0, _hooks.useCallback)((function(location) {
        __state_cachedVariables.location = location
    }), []);
    var __getMinOffset = (0, _hooks.useCallback)((function() {
        return -Math.max(props.contentSize - props.containerSize, 0)
    }), [props.contentSize, props.containerSize]);
    var __initHandler = (0, _hooks.useCallback)((function(e, action, crossThumbScrolling) {
        var stopDeferred = (0, _deferred.Deferred)();
        __prepareThumbScrolling(e, crossThumbScrolling);
        null === action || void 0 === action ? void 0 : action(e);
        return stopDeferred.promise()
    }), [props.scrollByThumb, props.scrollableOffset, props.direction, __state_cachedVariables, props.containerSize, props.contentSize, props.containerRef, props.bounceEnabled, props.scaleRatio, props.showScrollbar]);
    var __moveHandler = (0, _hooks.useCallback)((function(delta) {
        if (__state_cachedVariables.crossThumbScrolling) {
            return
        }
        var distance = delta;
        if (__state_cachedVariables.thumbScrolling) {
            distance[__getAxis()] = -Math.round(distance[__getAxis()] / __containerToContentRatio())
        }
        __scrollBy(distance)
    }), [__state_cachedVariables, props.direction, props.containerSize, props.contentSize, props.bounceEnabled, props.scaleRatio, props.containerRef, props.showScrollbar]);
    var __endHandler = (0, _hooks.useCallback)((function(e, action) {
        __state_cachedVariables.velocity = e.velocity[__getAxis()];
        __inertiaHandler();
        __resetThumbScrolling();
        null === action || void 0 === action ? void 0 : action(e)
    }), [props.direction, props.inertiaEnabled, __state_cachedVariables]);
    var __stopHandler = (0, _hooks.useCallback)((function() {
        __resetThumbScrolling()
    }), []);
    (0, _hooks.useEffect)((function() {
        _short.dxPointerDown.on(__scrollRef.current, (function() {
            __feedbackOn()
        }), {
            namespace: "dxScrollbar"
        });
        return function() {
            return _short.dxPointerDown.off(__scrollRef.current, {
                namespace: "dxScrollbar"
            })
        }
    }), []);
    (0, _hooks.useEffect)((function() {
        _short.dxPointerUp.on(_dom_adapter.default.getDocument(), (function() {
            __feedbackOff()
        }), {
            namespace: "dxScrollbar"
        });
        return function() {
            return _short.dxPointerUp.off(__scrollRef.current, {
                namespace: "dxScrollbar"
            })
        }
    }), []);
    (0, _hooks.useImperativeHandle)(ref, (function() {
        return {
            moveTo: __moveTo,
            isThumb: __isThumb,
            isScrollbar: __isScrollbar,
            validateEvent: __validateEvent,
            reachedMin: __reachedMin,
            reachedMax: __reachedMax,
            getLocation: __getLocation,
            setLocation: __setLocation,
            getMinOffset: __getMinOffset,
            initHandler: __initHandler,
            moveHandler: __moveHandler,
            endHandler: __endHandler,
            stopHandler: __stopHandler
        }
    }), [__moveTo, __isThumb, __isScrollbar, __validateEvent, __reachedMin, __reachedMax, __getLocation, __setLocation, __getMinOffset, __initHandler, __moveHandler, __endHandler, __stopHandler]);
    return viewFunction({
        props: _objectSpread({}, props),
        active: __state_active,
        cachedVariables: __state_cachedVariables,
        scrollbarRef: __scrollbarRef,
        scrollRef: __scrollRef,
        calculateScrollBarPosition: __calculateScrollBarPosition,
        inBounds: __inBounds,
        boundLocation: __boundLocation,
        getMaxOffset: __getMaxOffset,
        getAxis: __getAxis,
        getProp: __getProp,
        inertiaHandler: __inertiaHandler,
        suppressInertia: __suppressInertia,
        resetThumbScrolling: __resetThumbScrolling,
        scrollBy: __scrollBy,
        prepareThumbScrolling: __prepareThumbScrolling,
        moveToMouseLocation: __moveToMouseLocation,
        scrollStep: __scrollStep,
        getContainerRef: __getContainerRef,
        suppressBounce: __suppressBounce,
        move: __move,
        moveContent: __moveContent,
        moveContentByTranslator: __moveContentByTranslator,
        thumbSize: __thumbSize,
        thumbRatio: __thumbRatio,
        containerToContentRatio: __containerToContentRatio,
        baseContainerToContentRatio: __baseContainerToContentRatio,
        cssClasses: __cssClasses(),
        styles: __styles(),
        scrollClasses: __scrollClasses(),
        isVisible: __isVisible(),
        hoverStateEnabled: __hoverStateEnabled(),
        restAttributes: __restAttributes()
    })
}));
exports.Scrollbar = Scrollbar;
Scrollbar.defaultProps = _objectSpread({}, ScrollbarPropsType);
