/**
 * DevExtreme (ui/scheduler/header/header.js)
 * Version: 21.1.0 (build 21032-0316)
 * Build date: Mon Feb 01 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.Header = void 0;
var _renderer = _interopRequireDefault(require("../../../core/renderer"));
var _type = require("../../../core/utils/type");
var _extend = require("../../../core/utils/extend");
var _iterator = require("../../../core/utils/iterator");
var _array = require("../../../core/utils/array");
var _inflector = require("../../../core/utils/inflector");
var _component_registrator = _interopRequireDefault(require("../../../core/component_registrator"));
var _ui = _interopRequireDefault(require("../../widget/ui.widget"));
var _navigator = require("./navigator");
var _drop_down_menu = _interopRequireDefault(require("../../drop_down_menu"));
var _tabs = _interopRequireDefault(require("../../tabs"));
var _constants = require("../../tabs/constants");
var _errors = _interopRequireDefault(require("../../../core/errors"));
var _message = _interopRequireDefault(require("../../../localization/message"));

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function")
    }
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    return Constructor
}

function _get(target, property, receiver) {
    if ("undefined" !== typeof Reflect && Reflect.get) {
        _get = Reflect.get
    } else {
        _get = function(target, property, receiver) {
            var base = _superPropBase(target, property);
            if (!base) {
                return
            }
            var desc = Object.getOwnPropertyDescriptor(base, property);
            if (desc.get) {
                return desc.get.call(receiver)
            }
            return desc.value
        }
    }
    return _get(target, property, receiver || target)
}

function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
        object = _getPrototypeOf(object);
        if (null === object) {
            break
        }
    }
    return object
}

function _inherits(subClass, superClass) {
    if ("function" !== typeof superClass && null !== superClass) {
        throw new TypeError("Super expression must either be null or a function")
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) {
        _setPrototypeOf(subClass, superClass)
    }
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}

function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();
    return function() {
        var result, Super = _getPrototypeOf(Derived);
        if (hasNativeReflectConstruct) {
            var NewTarget = _getPrototypeOf(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget)
        } else {
            result = Super.apply(this, arguments)
        }
        return _possibleConstructorReturn(this, result)
    }
}

function _possibleConstructorReturn(self, call) {
    if (call && ("object" === _typeof(call) || "function" === typeof call)) {
        return call
    }
    return _assertThisInitialized(self)
}

function _assertThisInitialized(self) {
    if (void 0 === self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called")
    }
    return self
}

function _isNativeReflectConstruct() {
    if ("undefined" === typeof Reflect || !Reflect.construct) {
        return false
    }
    if (Reflect.construct.sham) {
        return false
    }
    if ("function" === typeof Proxy) {
        return true
    }
    try {
        Date.prototype.toString.call(Reflect.construct(Date, [], (function() {})));
        return true
    } catch (e) {
        return false
    }
}

function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
        return o.__proto__ || Object.getPrototypeOf(o)
    };
    return _getPrototypeOf(o)
}
var COMPONENT_CLASS = "dx-scheduler-header";
var VIEW_SWITCHER_CLASS = "dx-scheduler-view-switcher";
var VIEW_SWITCHER_LABEL_CLASS = "dx-scheduler-view-switcher-label";
var STEP_MAP = {
    day: "day",
    week: "week",
    workWeek: "workWeek",
    month: "month",
    timelineDay: "day",
    timelineWeek: "week",
    timelineWorkWeek: "workWeek",
    timelineMonth: "month",
    agenda: "agenda"
};
var VIEWS = ["day", "week", "workWeek", "month", "timelineDay", "timelineWeek", "timelineWorkWeek", "timelineMonth", "agenda"];
var Header = function(_Widget) {
    _inherits(Header, _Widget);
    var _super = _createSuper(Header);

    function Header() {
        _classCallCheck(this, Header);
        return _super.apply(this, arguments)
    }
    _createClass(Header, [{
        key: "_getDefaultOptions",
        value: function() {
            return (0, _extend.extend)(_get(_getPrototypeOf(Header.prototype), "_getDefaultOptions", this).call(this), {
                views: [],
                isAdaptive: false,
                intervalCount: 1,
                currentView: "day",
                firstDayOfWeek: void 0,
                currentDate: new Date,
                min: void 0,
                max: void 0,
                useDropDownViewSwitcher: false,
                _dropDownButtonIcon: "overlay"
            })
        }
    }, {
        key: "_setOptionsByReference",
        value: function() {
            _get(_getPrototypeOf(Header.prototype), "_setOptionsByReference", this).call(this);
            (0, _extend.extend)(this._optionsByReference, {
                currentView: true
            })
        }
    }, {
        key: "_optionChanged",
        value: function(args) {
            var value = args.value;
            switch (args.name) {
                case "views":
                    this._validateViews();
                    this._viewSwitcher.option({
                        items: value,
                        selectedItem: this.option("currentView")
                    });
                    break;
                case "customizeDateNavigatorText":
                    this._navigator.option(args.name, value);
                    break;
                case "currentView":
                    this._viewSwitcher.option("selectedItem", value);
                    this._navigator.option("step", STEP_MAP[this._getCurrentViewType()]);
                    this._changeViewSwitcherLabelText();
                    break;
                case "currentDate":
                    this._navigator.option("date", value);
                    break;
                case "displayedDate":
                    this._navigator.option("displayedDate", value);
                    break;
                case "min":
                case "max":
                case "firstDayOfWeek":
                case "intervalCount":
                    this._navigator.option(args.name, value);
                    break;
                case "tabIndex":
                case "focusStateEnabled":
                    this._viewSwitcher.option(args.name, value);
                    this._navigator.option(args.name, value);
                    _get(_getPrototypeOf(Header.prototype), "_optionChanged", this).call(this, args);
                    break;
                case "useDropDownViewSwitcher":
                    this._refreshViewSwitcher();
                    break;
                default:
                    _get(_getPrototypeOf(Header.prototype), "_optionChanged", this).call(this, args)
            }
        }
    }, {
        key: "_init",
        value: function() {
            _get(_getPrototypeOf(Header.prototype), "_init", this).call(this);
            this.$element().addClass(COMPONENT_CLASS)
        }
    }, {
        key: "_initMarkup",
        value: function() {
            _get(_getPrototypeOf(Header.prototype), "_initMarkup", this).call(this);
            this._renderNavigator();
            this._renderViewSwitcher()
        }
    }, {
        key: "_renderNavigator",
        value: function() {
            this._navigator = this._createComponent("<div>", _navigator.Navigator, {
                min: this.option("min"),
                max: this.option("max"),
                intervalCount: this.option("intervalCount"),
                date: this.option("currentDate"),
                step: STEP_MAP[this._getCurrentViewType()],
                firstDayOfWeek: this.option("firstDayOfWeek"),
                tabIndex: this.option("tabIndex"),
                focusStateEnabled: this.option("focusStateEnabled"),
                observer: this.option("observer"),
                customizeDateNavigatorText: this.option("customizeDateNavigatorText"),
                todayDate: this.option("todayDate")
            });
            this._navigator.$element().appendTo(this.$element())
        }
    }, {
        key: "_renderViewSwitcher",
        value: function() {
            this._validateViews();
            var $viewSwitcher = (0, _renderer.default)("<div>").addClass(VIEW_SWITCHER_CLASS).appendTo(this.$element());
            this.option("useDropDownViewSwitcher") ? this._renderViewSwitcherDropDownMenu($viewSwitcher) : this._renderViewSwitcherTabs($viewSwitcher)
        }
    }, {
        key: "_validateViews",
        value: function() {
            var views = this.option("views");
            (0, _iterator.each)(views, (function(_, view) {
                var isViewIsObject = (0, _type.isObject)(view);
                var viewType = isViewIsObject && view.type ? view.type : view;
                if (-1 === (0, _array.inArray)(viewType, VIEWS)) {
                    _errors.default.log("W0008", viewType)
                }
            }))
        }
    }, {
        key: "_getCurrentViewType",
        value: function() {
            var currentView = this.option("currentView");
            return currentView.type || currentView
        }
    }, {
        key: "_renderViewSwitcherTabs",
        value: function($element) {
            var that = this;
            $element.addClass(_constants.TABS_EXPANDED_CLASS);
            this._viewSwitcher = this._createComponent($element, _tabs.default, {
                selectionRequired: true,
                scrollingEnabled: true,
                onSelectionChanged: this._updateCurrentView.bind(this),
                items: this.option("views"),
                itemTemplate: function(item) {
                    return (0, _renderer.default)("<span>").addClass("dx-tab-text").text(that._getItemText(item))
                },
                selectedItem: this.option("currentView"),
                tabIndex: this.option("tabIndex"),
                focusStateEnabled: this.option("focusStateEnabled")
            })
        }
    }, {
        key: "_getItemText",
        value: function(item) {
            return item.name || _message.default.format("dxScheduler-switcher" + (0, _inflector.camelize)(item.type || item, true))
        }
    }, {
        key: "_refreshViewSwitcher",
        value: function() {
            this._viewSwitcher._dispose();
            this._viewSwitcher.$element().remove();
            delete this._viewSwitcher;
            this._removeViewSwitcherLabel();
            this._renderViewSwitcher()
        }
    }, {
        key: "_removeViewSwitcherLabel",
        value: function() {
            if ((0, _type.isDefined)(this._$viewSwitcherLabel)) {
                this._$viewSwitcherLabel.detach();
                this._$viewSwitcherLabel.remove();
                delete this._$viewSwitcherLabel
            }
        }
    }, {
        key: "_renderViewSwitcherDropDownMenu",
        value: function($element) {
            var that = this;
            this._$viewSwitcherLabel = (0, _renderer.default)("<div>").addClass(VIEW_SWITCHER_LABEL_CLASS).appendTo(this.$element());
            this._changeViewSwitcherLabelText();
            this._viewSwitcher = this._createComponent($element, _drop_down_menu.default, {
                onItemClick: this._updateCurrentView.bind(this),
                buttonIcon: this.option("_dropDownButtonIcon"),
                items: this.option("views"),
                selectionMode: this.option("isAdaptive") ? "single" : "none",
                selectedItemKeys: [this.option("currentView")],
                itemTemplate: function(item) {
                    return (0, _renderer.default)("<span>").addClass("dx-dropdownmenu-item-text").text(that._getItemText(item))
                }
            })
        }
    }, {
        key: "_changeViewSwitcherLabelText",
        value: function() {
            if (!(0, _type.isDefined)(this._$viewSwitcherLabel)) {
                return
            }
            var currentView = this.option("currentView");
            var currentViewText = this._getItemText(currentView);
            this._$viewSwitcherLabel.text(currentViewText)
        }
    }, {
        key: "_getCurrentViewName",
        value: function(currentView) {
            return (0, _type.isObject)(currentView) ? currentView.name || currentView.type : currentView
        }
    }, {
        key: "_updateCurrentView",
        value: function(e) {
            var selectedItem = e.itemData || e.component.option("selectedItem");
            var viewName = this._getCurrentViewName(selectedItem);
            this.notifyObserver("currentViewUpdated", viewName)
        }
    }, {
        key: "_renderFocusTarget",
        value: function() {}
    }, {
        key: "notifyObserver",
        value: function(subject, args) {
            var observer = this.option("observer");
            if (observer) {
                observer.fire(subject, args)
            }
        }
    }, {
        key: "invoke",
        value: function() {
            var observer = this.option("observer");
            if (observer) {
                return observer.fire.apply(observer, arguments)
            }
        }
    }]);
    return Header
}(_ui.default);
exports.Header = Header;
(0, _component_registrator.default)("dxSchedulerHeader", Header);
